/* Continuous Time Bayesian Network Reasoning and Learning Engine
 * Copyright (C) 2009 The Regents of the University of California
 *
 * Authored by Yu Fan, William Lam, Joon Lee, Christian Shelton, and Jing Xu
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _CTBN_H_
#define _CTBN_H_

#include "markov.h"
#include "structure.h" 
#include "markovdyn.h"
#include "bn.h"

class CTBN : public Markov
{
	SOBJCLASSDECL(CTBN)
public:
	CTBN(RV *startdist, Dynamics *dyn);
	CTBN(std::istream &is);
	CTBN(const Markov &m);
	CTBN &operator=(const CTBN &ctbn);
	virtual ~CTBN() {};

	CTBN *Clone() const;

	/*   int NumofVars() const{return d->Domain().NumVars();}; */
	/*   int NumofNodes() const {return dynamic_cast<const CTBNDyn*>(d)->NumofNodes();}; */
	/*   const Context &Domain() const{return d->Domain();}; */
	/*   const BN* InitRV() const {return dynamic_cast<const BN*>(p0);}; */
	/*   //const RV* InitRV() const {return p0;}; */
	const MarkovDyn* Node(int i) const;
	const CTBNDyn *CTBNDynamic() const;
	void GetStructure(Structure &s) const;
};
#endif
