/* Continuous Time Bayesian Network Reasoning and Learning Engine
 * Copyright (C) 2009 The Regents of the University of California
 *
 * Authored by Yu Fan, William Lam, Joon Lee, Christian Shelton, and Jing Xu
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _MULTIRV_H_
#define _MULTIRV_H_

#include "rvcomp.h"
#include "rvsimple.h"
#include "multisimple.h"

// just a wrapper to make things simpler
class MultiRV : public RVComp {
	SOBJCLASSDECL(MultiRV)
public:
	MultiRV(const Context &var, const Context &cvar);
	MultiRV(std::istream &is);
	virtual ~MultiRV();

	virtual MultiRV *Clone() const;

	MultiZSimple &operator[](int i) {
		RVCondSimpleComp<MultiZSimple> *ptr =
			dynamic_cast<RVCondSimpleComp<MultiZSimple> *>(Base());
		return ptr->operator[](i);
	}
	const MultiZSimple &operator[](int i) const {
		const RVCondSimpleComp<MultiZSimple> *ptr =
			dynamic_cast<const RVCondSimpleComp<MultiZSimple> *>(Base());
		return ptr->operator[](i);
	}

	MultiZSimple &operator[](const Instantiation &i) {
		RVCondSimpleComp<MultiZSimple> *ptr =
			dynamic_cast<RVCondSimpleComp<MultiZSimple> *>(Base());
		return ptr->operator[](CondDomain().Index(i));
	}
	const MultiZSimple &operator[](const Instantiation &i) const {
		const RVCondSimpleComp<MultiZSimple> *ptr =
			dynamic_cast<const RVCondSimpleComp<MultiZSimple> *>(Base());
		return ptr->operator[](CondDomain().Index(i));
	}
};

#endif
